DittoCode::HoldFile.if 'ENTERPRISE'

#######################################################################
# Copyright (c) 2024 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# Provide API methods to work with organizations
#
class Api::V1::IncidentsController < Api::V1::BaseSensorsController
  # ----------------------------------------------
  # Before and after actions
  # ----------------------------------------------
  # skip_before_action :authenticate_user_from_token!, :user_setup_api

  #
  # POST /api/v1/incidents/create
  #
  def create
    incident = Incident.new(incident_params)
    
    # Get priority by name or get the first one (critical)
    priority = Priority.find_by(name: params[:priority]) if params[:priority]
    priority = Priority.all.first unless priority
    incident.priority_id = priority.id

    incident.incident_status = IncidentStatus.find_by(name: IncidentStatus::NEW)

    if incident.save
      render json: { success: true, id: incident.id }, status: :created
    else
      render json: { 
        success: false, 
        errors: incident.errors.full_messages 
      }, status: :unprocessable_entity
    end
  end # create
  
  private

  #
  # Define the params to create a domain.
  #
  def incident_params
    params.require(:incident).permit(:name, :priority, :uuid, :source)
  end
end